Index: pjproject/trunk/pjsip-apps/build/Samples-vc.mak
===================================================================
--- pjproject/trunk/pjsip-apps/build/Samples-vc.mak	(revision 875)
+++ pjproject/trunk/pjsip-apps/build/Samples-vc.mak	(revision 876)
@@ -45,4 +45,5 @@
 	  $(BINDIR)\resampleplay.exe \
 	  $(BINDIR)\simpleua.exe \
+	  $(BINDIR)\simple_pjsua.exe \
 	  $(BINDIR)\siprtp.exe \
 	  $(BINDIR)\sipstateless.exe \
Index: pjproject/trunk/pjsip-apps/build/Samples.mak
===================================================================
--- pjproject/trunk/pjsip-apps/build/Samples.mak	(revision 875)
+++ pjproject/trunk/pjsip-apps/build/Samples.mak	(revision 876)
@@ -48,4 +48,5 @@
 	   resampleplay \
 	   simpleua \
+	   simple_pjsua \
 	   siprtp \
 	   sipstateless \
Index: pjproject/trunk/pjsip-apps/build/samples.dsp
===================================================================
--- pjproject/trunk/pjsip-apps/build/samples.dsp	(revision 875)
+++ pjproject/trunk/pjsip-apps/build/samples.dsp	(revision 876)
@@ -127,4 +127,8 @@
 # Begin Source File
 
+SOURCE=..\src\samples\simple_pjsua.c
+# End Source File
+# Begin Source File
+
 SOURCE=..\src\samples\simpleua.c
 # End Source File
Index: pjproject/trunk/pjsip-apps/src/samples/simple_pjsua.c
===================================================================
--- pjproject/trunk/pjsip-apps/src/samples/simple_pjsua.c	(revision 876)
+++ pjproject/trunk/pjsip-apps/src/samples/simple_pjsua.c	(revision 876)
@@ -0,0 +1,197 @@
+/* $Id$ */
+/* 
+ * Copyright (C) 2003-2006 Benny Prijono <benny@prijono.org>
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
+ */
+
+/**
+ * simple_pjsua.c
+ *
+ * This is a very simple but fully featured SIP user agent, with the 
+ * following capabilities:
+ *  - SIP registration
+ *  - Making and receiving call
+ *  - Audio/media to sound device.
+ *
+ * Usage:
+ *  - To make outgoing call, start simple_pjsua with the URL of remote
+ *    destination to contact.
+ *    E.g.:
+ *	 simpleua sip:user@remote
+ *
+ *  - Incoming calls will automatically be answered with 200.
+ *
+ * This program will quit once it has completed a single call.
+ */
+
+#include <pjsua-lib/pjsua.h>
+
+#define THIS_FILE	"APP"
+
+#define SIP_DOMAIN	"example.com"
+#define SIP_USER	"alice"
+#define SIP_PASSWD	"secret"
+
+
+/* Callback called by the library upon receiving incoming call */
+static void on_incoming_call(pjsua_acc_id acc_id, pjsua_call_id call_id,
+			     pjsip_rx_data *rdata)
+{
+    pjsua_call_info ci;
+
+    PJ_UNUSED_ARG(acc_id);
+    PJ_UNUSED_ARG(rdata);
+
+    pjsua_call_get_info(call_id, &ci);
+
+    PJ_LOG(3,(THIS_FILE, "Incoming call from %.*s!!",
+			 (int)ci.remote_info.slen,
+			 ci.remote_info.ptr));
+
+    /* Automatically answer incoming calls with 200/OK */
+    pjsua_call_answer(call_id, 200, NULL, NULL);
+}
+
+/* Callback called by the library when call's state has changed */
+static void on_call_state(pjsua_call_id call_id, pjsip_event *e)
+{
+    pjsua_call_info ci;
+
+    PJ_UNUSED_ARG(e);
+
+    pjsua_call_get_info(call_id, &ci);
+    PJ_LOG(3,(THIS_FILE, "Call %d state=%.*s", call_id,
+			 (int)ci.state_text.slen,
+			 ci.state_text.ptr));
+}
+
+/* Callback called by the library when call's media state has changed */
+static void on_call_media_state(pjsua_call_id call_id)
+{
+    pjsua_call_info ci;
+
+    pjsua_call_get_info(call_id, &ci);
+
+    if (ci.media_status == PJSUA_CALL_MEDIA_ACTIVE) {
+	// When media is active, connect call to sound device.
+	pjsua_conf_connect(ci.conf_slot, 0);
+	pjsua_conf_connect(0, ci.conf_slot);
+    }
+}
+
+/* Display error and exit application */
+static void error_exit(const char *title, pj_status_t status)
+{
+    pjsua_perror(THIS_FILE, title, status);
+    pjsua_destroy();
+    exit(1);
+}
+
+/*
+ * main()
+ *
+ * argv[1] may contain URL to call.
+ */
+int main(int argc, char *argv[])
+{
+    pjsua_acc_id acc_id;
+    pj_status_t status;
+
+    /* Create pjsua first! */
+    status = pjsua_create();
+    if (status != PJ_SUCCESS) error_exit("Error in pjsua_create()", status);
+
+    /* If argument is specified, it's got to be a valid SIP URL */
+    if (argc > 1) {
+	status = pjsua_verify_sip_url(argv[1]);
+	if (status != PJ_SUCCESS) error_exit("Invalid URL in argv", status);
+    }
+
+    /* Init pjsua */
+    {
+	pjsua_config cfg;
+	pjsua_logging_config log_cfg;
+
+	pjsua_config_default(&cfg);
+	cfg.cb.on_incoming_call = &on_incoming_call;
+	cfg.cb.on_call_media_state = &on_call_media_state;
+	cfg.cb.on_call_state = &on_call_state;
+
+	pjsua_logging_config_default(&log_cfg);
+	log_cfg.console_level = 4;
+
+	status = pjsua_init(&cfg, &log_cfg, NULL);
+	if (status != PJ_SUCCESS) error_exit("Error in pjsua_init()", status);
+    }
+
+    /* Add UDP transport. */
+    {
+	pjsua_transport_config cfg;
+
+	pjsua_transport_config_default(&cfg);
+	cfg.port = 5060;
+	status = pjsua_transport_create(PJSIP_TRANSPORT_UDP, &cfg, NULL);
+	if (status != PJ_SUCCESS) error_exit("Error creating transport", status);
+    }
+
+    /* Initialization is done, now start pjsua */
+    status = pjsua_start();
+    if (status != PJ_SUCCESS) error_exit("Error starting pjsua", status);
+
+    /* Register to SIP server by creating SIP account. */
+    {
+	pjsua_acc_config cfg;
+
+	pjsua_acc_config_default(&cfg);
+	cfg.id = pj_str("sip:" SIP_USER "@" SIP_DOMAIN);
+	cfg.reg_uri = pj_str("sip:" SIP_DOMAIN);
+	cfg.cred_count = 1;
+	cfg.cred_info[0].realm = pj_str(SIP_DOMAIN);
+	cfg.cred_info[0].scheme = pj_str("digest");
+	cfg.cred_info[0].username = pj_str(SIP_USER);
+	cfg.cred_info[0].data_type = PJSIP_CRED_DATA_PLAIN_PASSWD;
+	cfg.cred_info[0].data = pj_str(SIP_PASSWD);
+
+	status = pjsua_acc_add(&cfg, PJ_TRUE, &acc_id);
+	if (status != PJ_SUCCESS) error_exit("Error adding account", status);
+    }
+
+    /* If URL is specified, make call to the URL. */
+    if (argc > 1) {
+	pj_str_t uri = pj_str(argv[1]);
+	status = pjsua_call_make_call(acc_id, &uri, 0, NULL, NULL, NULL);
+	if (status != PJ_SUCCESS) error_exit("Error making call", status);
+    }
+
+    /* Wait until user press "q" to quit. */
+    for (;;) {
+	char option[10];
+
+	puts("Press 'h' to hangup all calls, 'q' to quit");
+	fgets(option, sizeof(option), stdin);
+
+	if (option[0] == 'q')
+	    break;
+
+	if (option[0] == 'h')
+	    pjsua_call_hangup_all();
+    }
+
+    /* Destroy pjsua */
+    pjsua_destroy();
+
+    return 0;
+}
Index: pjproject/trunk/pjsip/docs/doxygen.h
===================================================================
--- pjproject/trunk/pjsip/docs/doxygen.h	(revision 875)
+++ pjproject/trunk/pjsip/docs/doxygen.h	(revision 876)
@@ -199,4 +199,8 @@
     media to the sound device.
     
+  - @ref page_pjsip_sample_simple_pjsuaua_c\n
+    Very simple SIP User Agent with registration, call, and media, using
+    PJSUA-API, all in under 200 lines of code.
+
   - @ref page_pjsip_samples_pjsua\n
     This is the reference implementation for PJSIP and PJMEDIA.
@@ -252,4 +256,13 @@
 
 /**
+ * \page page_pjsip_sample_simple_pjsuaua_c Samples: Simple PJSUA
+ *
+ * Very simple SIP User Agent with registration, call, and media, all
+ * in under 200 lines of code.
+ *
+ * \includelineno simple_pjsua.c
+ */
+
+/**
  * \page page_pjsip_sample_sipstateless_c Samples: Stateless SIP Endpoint
  *